import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.Scanner;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 * Listener class for the ButtonPanel class
 * @author Marcio B
 *
 */
public class ButtonPanelMenuListener implements ActionListener {
	  private DigitalCircuit circuit;
	  private JFrame frame;
	  /**
	   * Constructor of the class
	   * @param c DigitalCircuit
	   * @param f JFrame
	   */
	  public ButtonPanelMenuListener (DigitalCircuit c,JFrame f) {
	     circuit = c;
	     frame = f;
	  }
	  /**
	   * Takes the action and do a method
	   */
	  public void actionPerformed(ActionEvent e) {
	     JButton b = (JButton)(e.getSource());
	      String text = b.getText();
	     
	      if (text.equals("Start"))
	    	  circuit.simulate();

	      if (text.equals("Wire")) 
	    	  circuit.addWire();
	      
	      if (text.equals("OPEN")){ 
	          FileReader data=null;
	          JFileChooser chooser = new JFileChooser();
	          FileNameExtensionFilter filter = new FileNameExtensionFilter(".dc data files", "dc");
	          chooser.setFileFilter(filter);
	          int returnVal = chooser.showOpenDialog(null);
	          if(returnVal == JFileChooser.APPROVE_OPTION) {
	            try {
	              data = new FileReader(chooser.getSelectedFile());
	            } catch(FileNotFoundException ef) {
	          	  JOptionPane.showMessageDialog(null, "Can't open the file.\nPlease try again. ","Error", JOptionPane.ERROR_MESSAGE);  
	              return;
	            }
	            circuit.addOpenFile(data);
	          }
	        }
	      
	      if (text.equals("SAVE")){
	    	  PrintStream outData = null;
	    	  JFileChooser fc = new JFileChooser();
	    	  FileNameExtensionFilter fil = new FileNameExtensionFilter(".dc", "dc");
	    	  fc.setFileFilter(fil);

	    	  int returnV = fc.showSaveDialog(null);
	    	  if(returnV == JFileChooser.APPROVE_OPTION) {
	    		  try {
	    			  outData = new PrintStream(fc.getSelectedFile());
	    		  } catch(FileNotFoundException ef) {
	    			  JOptionPane.showMessageDialog(null, "Can't save the file.\nPlease try again. ","Error", JOptionPane.ERROR_MESSAGE);

	    			  return;
	    		  }
	    		  circuit.addSaveFile(outData);
	    	  }
	      }
	      
	      if (text.equals("Source")) {
	    	  Scanner data=null;
	    	  JFileChooser chooser = new JFileChooser();
	    	  FileNameExtensionFilter filter = new FileNameExtensionFilter(".txt data files", "txt");
	    	  chooser.setFileFilter(filter);
	    	  int returnVal = chooser.showOpenDialog(null);
	    	
	    		  if(returnVal == JFileChooser.APPROVE_OPTION) {
	    			  try {
	    				  data= new Scanner(chooser.getSelectedFile());
	    			  } catch(FileNotFoundException ef) {
	    				  JOptionPane.showMessageDialog(null, "Can't open the file.\nPlease try again. ","Error", JOptionPane.ERROR_MESSAGE);  
	    				  return;
	    			  }
	    				  
	    			if(!data.hasNext()){
	    				JOptionPane.showMessageDialog(null, "File is EMPTY.\nPlease try again. ","Error", JOptionPane.ERROR_MESSAGE);
	    			}else circuit.addSource(data);
	    		  }
	    	   
	      }


	      if (text.equals("Meter")) {
	    	  PrintStream outDat = null;
	    	  JFileChooser fcho = new JFileChooser();
	    	  FileNameExtensionFilter filer = new FileNameExtensionFilter(".txt", "txt");
	    	  fcho.setFileFilter(filer);

	    	  int returnVe = fcho.showSaveDialog(null);
	    	  if(returnVe == JFileChooser.APPROVE_OPTION) {
	    		  try {
	    			  outDat = new PrintStream(fcho.getSelectedFile());
	    		  } catch(FileNotFoundException ef) {
	    			  JOptionPane.showMessageDialog(null, "Can't save the file.\nPlease try again. ","Error", JOptionPane.ERROR_MESSAGE);

	    			  return;
	    		  }
	    		  circuit.addMeter(outDat,frame);
	    	  }

	      }

	  }

	}
