public class ChangeEvent implements Comparable{
  private UpdateListener listener;
  private float time;
  private boolean value;
  
  public ChangeEvent (UpdateListener l, boolean val, float t) {
    listener = l;
    value = val;
    time = t;
  }
  
  public int compareTo(Object o) {
     ChangeEvent e = (ChangeEvent) o;
     return (int)(time - e.time);
  }
  /**
   * Perform print to console and update the output values 
   * @param s Simulator
   */
  public void performUpdate (Simulator s) {
    listener.updateOutputValue(value);
    System.out.println(s.getTime()+"\t"+listener.getClass().getSimpleName()+"\t"+value);
  }
  /**
   * Propagate output update
   */
  public void notifyUpdate () {
    listener.propagateOutputValue();
  }
  /**
   * Get the time
   */
  public float getTime() {
    return time;
  }
}