import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;


public class EditMenuListener implements ActionListener {
  private DigitalCircuit circuit;
  private JFrame frame;
  public EditMenuListener (DigitalCircuit c,JFrame f) {
     circuit = c;
     frame = f;
  }
  public void actionPerformed(ActionEvent e) {
      JMenuItem menuItem = (JMenuItem)(e.getSource());
      String text = menuItem.getText();
     
      if (text.equals("Inverter")) 
    	  circuit.addInverter();
      if (text.equals("Or")) 
    	  circuit.addOrGate();

      if (text.equals("Nand")) 
    	  circuit.addNandGate();

      if (text.equals("And")) 
    	  circuit.addAndGate();
      
      if (text.equals("Xor")) 
    	  circuit.addXorGate();

      if (text.equals("Nor")) 
    	  circuit.addNorGate();

      if (text.equals("Wire")) 
    	  circuit.addWire();

      if (text.equals("Delete all")){
    	  int result = JOptionPane.showConfirmDialog(null,"You are going to delete all items ! Are you sure ? ","Delete All",JOptionPane.YES_NO_OPTION); 
    	  if (result == JOptionPane.YES_OPTION)  
    			  circuit.removeAll();
    	  }

      if (text.equals("Release Color")){
    	  circuit.changeRelColor();
      }
      if (text.equals("Selected Color")){
    	  circuit.changeSelColor();
      }
      if (text.equals("Source")) {
    	  Scanner data=null;
    	  JFileChooser chooser = new JFileChooser();
    	  FileNameExtensionFilter filter = new FileNameExtensionFilter(".txt data files", "txt");
    	  chooser.setFileFilter(filter);
    	  int returnVal = chooser.showOpenDialog(null);
    	  if(returnVal == JFileChooser.APPROVE_OPTION) {
    		  try {
    			  data= new Scanner(chooser.getSelectedFile());
    		  } catch(FileNotFoundException ef) {
    			  JOptionPane.showMessageDialog(null, "Can't open the file.\nPlease try again. ","Error", JOptionPane.ERROR_MESSAGE);  
    			  return;
    		  }
    		  if(!data.hasNext()){
  				JOptionPane.showMessageDialog(null, "File is EMPTY.\nPlease try again. ","Error", JOptionPane.ERROR_MESSAGE);
  			}else circuit.addSource(data);
    	  }
      }


      if (text.equals("Meter")) {
    	  PrintStream outDat = null;
    	  JFileChooser fcho = new JFileChooser();
    	  FileNameExtensionFilter filer = new FileNameExtensionFilter(".txt", "txt");
    	  fcho.setFileFilter(filer);

    	  int returnVe = fcho.showSaveDialog(null);
    	  if(returnVe == JFileChooser.APPROVE_OPTION) {
    		  try {
    			  outDat = new PrintStream(fcho.getSelectedFile());
    		  } catch(FileNotFoundException ef) {
    			  JOptionPane.showMessageDialog(null, "Can't save the file.\nPlease try again. ","Error", JOptionPane.ERROR_MESSAGE);

    			  return;
    		  }
    		  circuit.addMeter(outDat,frame);
    	  }

      }

  }

}


