import javax.swing.*; 
import org.jfree.data.xy.*;
import org.jfree.chart.*;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.StandardXYItemRenderer;
/**
 * Class to constructor JFreechart graphics
 * @author Marcio B 
 *
 */
public class GraphPanel extends JPanel{
	private JFreeChart[] chart;
	float maxPlotTime = 110;
	private XYSeriesCollection dataseries;
	NumberAxis rangeX;
	NumberAxis rangeY;
	/**
	 * Constructor of the class
	 * @param t float
	 */
	public GraphPanel(float t){
		XYSeries series;
		maxPlotTime = t;
		dataseries = new XYSeriesCollection();
		chart = new JFreeChart[1];
		rangeY = new NumberAxis();
		rangeX = new NumberAxis("t [s]");
		
		rangeX.setLowerBound(0);
		rangeX.setUpperBound(maxPlotTime);
		rangeY = new NumberAxis("S");
	
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		series = new XYSeries("",false);
		dataseries = new XYSeriesCollection(series);
		rangeX.setAutoRangeIncludesZero(false);
		rangeY.setAutoRangeIncludesZero(false);
		XYPlot plot = new XYPlot(dataseries, rangeX, rangeY, new StandardXYItemRenderer());
		chart[0] = new JFreeChart("",plot);
		chart[0].removeLegend();
		
		ChartPanel chartPanel = new ChartPanel(chart[0]);
	
		add(chartPanel);
	}
	/**
	 * Gives the name of the graph
	 * @param desc
	 */
	public void setDescription (String desc){
		
		chart[0].setTitle(desc);
	}
	/**
	 * Sets the number o the maximum plot time
	 * @return float maxPlotTime
	 */
	public float getMaxPlotTime(){
		return maxPlotTime;
	}
	
	/**
	 * Adds the values to the chart
	 * @param time
	 * @param value
	 */
	public void addPoint( float time, int value){
		dataseries.getSeries(0).add(time,value);
	}
}
