import java.awt.Graphics2D;
import java.io.PrintStream;
import java.util.ArrayList;

/**
 * 
 * @author Marcio B & Antonio M
 * @version v3
 */
public class Meter implements InSignal, UpdateListener{   
	private ArrayList <InSignal> drains;
	private PrintStream out;
	private OutSignal source;
	private Simulator sim;
	private Graphics2D line;
	private GraphFrame gf;
	private static int nextId=0;
	private final int id;
	  
	  {  id = nextId++;
	  }
	//private ScreenGraphic graph;
 
   /**
    * Constructor for NorGate class
    * @param s Simulator
    * @param os PrintStream
    */
	public Meter (PrintStream os, Simulator s, Graphics2D g, GraphFrame graf) {
		out = os;
		gf = graf;
		sim = s;
		source = null;
		sim.addMeter(this);
		drains = new ArrayList<InSignal>();
		//for draw the graphic
		g = line;
	}
	
	public int getId(){
		return id;
	}


	/**
    * Writes the name of the gates
    * to a PrintStream
    */
   public void writeHeader(){
     out.print("Time\t");
     out.println(source.getDescription()+"\t");
     
   }
   /**
    * Prints the values of the source for the time given.
    * @param time float
    */
   public void log(float time) {
      out.print( time + "\t" );
      out.print( ( source.getValue()?1:0 ) + "\t");
      out.println();
      gf.addValue( time, source.getValue()?1:0 );
      
   
   }
     
  
@Override
public void inputValueChanged() {
	// TODO Auto-generated method stub
    for ( InSignal s: drains )
        s.inputValueChanged(); 
}
@Override
public void connectInput(OutSignal output) {
	// TODO Auto-generated method stub
    source = output;
    output.connectDrain(this);
}
@Override
public void disconnectInput() {
	// TODO Auto-generated method stub
    if (source!=null) {
        source.removeFromDrains(this);
        source = null;
      }
}

@Override
public void addSource(OutSignal output) {
	// TODO Auto-generated method stub
    source=output;
}
@Override
public void removeFromSource(OutSignal output) {
	// TODO Auto-generated method stub
    if (source==output) source=null;
}
@Override
public void updateOutputValue(boolean newValue) {
	// TODO Auto-generated method stub
}
@Override
public void propagateOutputValue() {
	// TODO Auto-generated method stub	
}
}