
import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.*;

public class MouseListener extends MouseAdapter implements KeyListener {
   private DigitalCircuit circuit;
   private Drawable currentComponent;
   private JPanel panel;
   private Point last, current;
   public MouseListener (DigitalCircuit c, JPanel p){
      circuit = c;
      panel = p;
      last = current = null;
      panel.setFocusable(true);
      panel.addKeyListener(this);
   } 
   public void mouseMoved(MouseEvent e) {
      last = e.getPoint();
      Drawable newComponent = circuit.find(last);
      if (newComponent == currentComponent) return;
      if (currentComponent != null) {
         currentComponent.setReleased();
         currentComponent = null;
      }
      if (newComponent != null) { 
         currentComponent = newComponent;
         currentComponent.setSelected();
         
      }
      panel.repaint();
   }
   public void mouseDragged(MouseEvent e) {
      if (currentComponent == null) return; 
      current = e.getPoint();
      currentComponent.dragIn(current.x-last.x, current.y-last.y);
      last=current;
  
      panel.repaint();
   }
   public void mouseWheelMoved(MouseWheelEvent e) {
      if (currentComponent == null) return;
      currentComponent.flip();
      panel.repaint();
   }

   public void mouseReleased(MouseEvent e) {
      if (currentComponent instanceof GWire) {
          ((GWire)currentComponent).setReleased();
          ((GWire)currentComponent).tryToConnect();         
         panel.repaint();
      }
      
   }
   
@Override
public void keyPressed(KeyEvent e) {
	
}
@Override
public void keyReleased(KeyEvent e) {
	// TODO Auto-generated method stub
	if(e.getKeyChar() == 'd' & (currentComponent != null)){
		circuit.delete(currentComponent);
	}
	if(e.getKeyChar() == 'r' &	(currentComponent != null) &!(
			(currentComponent instanceof GWire)| 
			(currentComponent instanceof GSource)|
			(currentComponent instanceof GMeter))) { 

		circuit.setGateDelay(currentComponent);
	}
	
	if(e.getKeyChar() == 'g' & (currentComponent instanceof GMeter)){ 
	
		circuit.showGraph(currentComponent);
	}
}
@Override
public void keyTyped(KeyEvent e) {
	// TODO Auto-generated method stub
	
}
}