import java.io.PrintStream;
import java.util.ArrayList;
/**
 * Class SaveFile to save positions of gates
 * @author Marcio B
 *
 */
public class SaveFile {
	private ArrayList<Drawable> comp;
	private PrintStream d;
	/**
	 * Constructo of SaveFile class
	 * @param components ArrayList<Drawable>
	 * @param data PrintStream
	 */
	public SaveFile(ArrayList<Drawable> components, PrintStream data){
		comp = components;
		d = data;
	}
	/**
	 * Takes all de components in ArrayList<Drawable> from DigitalCircuit
	 * and writes them in .dc file
	 */
	public void write(){
		for(Drawable draw:comp){
			String c = draw.getClass().getName();
			 d.println( "GATE" );
			 if(c.compareTo("GWire") == 0){
				 d.println( c.substring( 1, c.length() ));
				 d.println( (int) ((GWire) draw).getInPos().getCenterX() );
				 d.println( (int) ((GWire) draw).getInPos().getCenterY() );
				 d.println( (int) ((GWire) draw).getOutPos().getCenterX() );
				 d.println( (int) ((GWire) draw).getOutPos().getCenterY() );
			
			 }else{ 
				 d.println( c.substring( 1, c.length()-4 ) );   //name 
				 d.println( draw.getIdDraw());				//id
				 d.println( (int)draw.getPos().getCurrentPoint().getX() );/// xpos 
				 d.println( (int)draw.getPos().getCurrentPoint().getY() ); /// y pos
				 d.println( (int)draw.getGDelay());  /// delay
			 }
			 
		}
	}

}
